Bug 729767 - imaps[9563]: unable to open Berkeley db /etc/sasldb2: Invalid argument after fixing sendmail from bug 712943
imaps[9563]: unable to open Berkeley db /etc/sasldb2: Invalid argument after ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: cyrus-imapd (Show other bugs)
15
i686 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Michal Hlavinka
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-08-10 14:50 EDT by Timothy Sink
Modified: 2011-10-15 20:57 EDT (History)
5 users (show)

See Also:
Fixed In Version: cyrus-imapd-2.4.12-1.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-10-13 19:55:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Timothy Sink 2011-08-10 14:50:59 EDT
Description of problem:
This seems to be a libdb 5.1 from libdb 4.x problem. the cyrus-imapd cannot connect to sasldb2.

Version-Release number of selected component (if applicable):
cyrus-sasl-2.1.23-18.fc15
cyrus-imapd-2.4.10-1.fc15 (or stable version prior)

How reproducible:
upgrade from fedora 14 - 15 caused problem with sendmail fixed in 
https://bugzilla.redhat.com/show_bug.cgi?id=712943
cyrus-imapd worked before applying fix.
that was a problem with sendmail compiled with sasldb.5.1 support and cyrus-sasl compiled with sasldb 4.8 support.

Steps to Reproduce:
1. fully working cyrus-imapd/sendmail system on fedora 14.
2. pre-upgrade to fedora 15
3. yum cyrus-sasl with the testing release cyrus-sasl-2.1.23-18.fc15
4. restart sendmail, cyrus-imapd, saslauthd

/etc/imapd-local.conf

postmaster: postmaster
configdirectory: /var/lib/imap
partition-default: /var/spool/imap
admins: cyrus root
allowanonymouslogin: no
allowplaintext: yes
servername: mail.myserver.com
autocreatequota: 20480
reject8bit: no
quotawarn: 90
timeout: 30
poptimeout: 10
dracinterval: 0
drachost: localhost
sievedir: /var/lib/imap/sieve
sendmail: /usr/sbin/sendmail
sieve_maxscriptsize: 32
sieve_maxscripts: 5
hashimapspool: true
sasl_pwcheck_method:auxprop saslauthd
sasl_auxprop_plugin:sasldb
sasl_mech_list: LOGIN PLAIN CRAM-MD5 DIGEST-MD5

5. imtest -m cram-md5 -a myuser
  
Actual results:

Please enter your password:
C: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
S: DB->put: method not permitted before handle's open method
base64 decoding error
Authentication failed. generic failure
Security strength factor: 0
DB->compact: method not permitted before handle's open method
DB->put: method not permitted before handle's open method
DB->compact: method not permitted before handle's open method
A01 NO authentication failure

/var/log/messages

imaplocal[9589]: unable to open Berkeley db /etc/sasldb2: Invalid argument

same result from client using imapd.conf which is configured the same for the most part.

Expected results:

should read the sasldb2 and login OK

Additional info:
fedora 15 on an x86.

I also tried yum the current testing release cyrus-imapd-2.4.10-1.fc15 but still the same thing.

testsaslauthd -u myuser -p mypassword
OK "Success."
Comment 1 Fedora Update System 2011-08-16 06:19:47 EDT
cyrus-imapd-2.4.10-4.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.10-4.fc16
Comment 2 Fedora Update System 2011-08-16 06:19:55 EDT
cyrus-imapd-2.4.10-2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.10-2.fc15
Comment 3 Fedora Update System 2011-08-16 16:08:52 EDT
Package cyrus-imapd-2.4.10-4.fc16:
* should fix your issue,
* was pushed to the Fedora 16 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing cyrus-imapd-2.4.10-4.fc16'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.10-4.fc16
then log in and leave karma (feedback).
Comment 4 Philip Prindeville 2011-08-24 14:05:34 EDT
Tried to install the new files:

sh-4.2# rpm -vhU /tmp/cyrus-imapd-*
error: Failed dependencies:
        libdb-utils is needed by cyrus-imapd-2.4.10-2.fc15.x86_64
sh-4.2# yum install libdb-utils
...
Transaction Check Error:
  file /usr/bin/db_archive from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_checkpoint from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_deadlock from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_dump from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_dump185 from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_hotbackup from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_load from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_printlog from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_recover from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_stat from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_upgrade from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64
  file /usr/bin/db_verify from install of libdb-utils-5.1.25-3.fc15.x86_64 conflicts with file from package db4-utils-4.8.30-3.fc15.x86_64

Error Summary
-------------

sh-4.2#
sh-4.2# rpm --test -e db4-utils
error: Failed dependencies:
        db4-utils is needed by (installed) rpm-4.9.1.1-1.fc15.x86_64
        db4-utils is needed by (installed) cyrus-imapd-2.4.10-1.fc15.x86_64
sh-4.2#


so how does one resolve the mutually exclusive dependencies?

Or does one ignore the warning, and remove it with:

rpm --nodeps -e db4-utils

and hope that rpm itself won't be damaged?
Comment 5 Philip Prindeville 2011-08-24 14:12:10 EDT
(In reply to comment #4)
> so how does one resolve the mutually exclusive dependencies?
> Or does one ignore the warning, and remove it with:
> rpm --nodeps -e db4-utils
> and hope that rpm itself won't be damaged?

Asked and answered: crossed my fingers tried.

Seems to have worked.

The dependencies in cyrus-imapd and rpm may need to change, or else the "provides" list of libdb-utils might be incorrect.
Comment 6 Michal Hlavinka 2011-08-25 08:38:21 EDT
> so how does one resolve the mutually exclusive dependencies?
...
> and hope that rpm itself won't be damaged?

yes, it's broken right now and unfortunately, there is only way forward, so it'll take some time. 

I'll fix it to be non-conflicting with db4-utils
Comment 7 Fedora Update System 2011-08-26 07:36:18 EDT
cyrus-imapd-2.4.10-3.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.10-3.fc15
Comment 8 Fedora Update System 2011-08-26 14:51:34 EDT
Package cyrus-imapd-2.4.10-3.fc15:
* should fix your issue,
* was pushed to the Fedora 15 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing cyrus-imapd-2.4.10-3.fc15'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.10-3.fc15
then log in and leave karma (feedback).
Comment 9 Artur 2011-08-29 06:05:05 EDT
Yes, cyrus-imapd-2.4.10-3.fc15 resolves the problem. Note, that similar issues are observed with other software, I had to recompile postfix as well to link it with libdb-5.1 instead of db4-4.8.
Comment 10 Michal Hlavinka 2011-08-29 08:07:25 EDT
(In reply to comment #9)
> Yes, cyrus-imapd-2.4.10-3.fc15 resolves the problem. Note, that similar issues
> are observed with other software, I had to recompile postfix as well to link it
> with libdb-5.1 instead of db4-4.8.

Please open bug against postfix, if there's not such bug yet. It's possible postfix maintainer does not know about this.
Comment 11 Jaroslav Škarvada 2011-08-29 08:26:00 EDT
> Please open bug against postfix, if there's not such bug yet. It's possible
> postfix maintainer does not know about this.
>
Bug 734084
Comment 12 Fedora Update System 2011-09-09 04:19:19 EDT
cyrus-imapd-2.4.11-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.11-1.fc15
Comment 13 Fedora Update System 2011-09-09 04:19:33 EDT
cyrus-imapd-2.4.11-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.11-1.fc16
Comment 14 Fedora Update System 2011-10-05 06:21:18 EDT
cyrus-imapd-2.4.12-1.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.12-1.fc15
Comment 15 Fedora Update System 2011-10-05 06:21:47 EDT
cyrus-imapd-2.4.12-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/cyrus-imapd-2.4.12-1.fc16
Comment 16 Fedora Update System 2011-10-13 19:55:05 EDT
cyrus-imapd-2.4.12-1.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2011-10-15 20:57:19 EDT
cyrus-imapd-2.4.12-1.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.